update-pciids.sh

来自「linux下的pci设备浏览工具」· Shell 代码 · 共 76 行

SH
76
字号
#!/bin/sh[ "$1" = "-q" ] && quiet=true || quiet=falseset -eSRC="http://pciids.sourceforge.net/v2.2/pci.ids"DEST=pci.idsPCI_COMPRESSED_IDS=GREP=grep# if pci.ids is read-only (because the filesystem is read-only),# then just skip this whole process.if ! touch ${DEST} >/dev/null 2>&1 ; then	${quiet} || echo "${DEST} is read-only, exiting." 1>&2	exit 1fiif [ -n "$PCI_COMPRESSED_IDS" ] ; then	DECOMP="cat"	SRC="$SRC.gz"	GREP=zgrepelif which bzip2 >/dev/null 2>&1 ; then	DECOMP="bzip2 -d"	SRC="$SRC.bz2"elif which gzip >/dev/null 2>&1 ; then	DECOMP="gzip -d"	SRC="$SRC.gz"else	DECOMP="cat"fiif which curl >/dev/null 2>&1 ; then	DL="curl -o $DEST.new $SRC"    ${quiet} && DL="$DL -s -S"elif which wget >/dev/null 2>&1 ; then	DL="wget --no-timestamping -O $DEST.new $SRC"	${quiet} && DL="$DL -q"elif which lynx >/dev/null 2>&1 ; then	DL="eval lynx -source $SRC >$DEST.new"else	echo >&2 "update-pciids: cannot find curl, wget or lynx"	exit 1fiif ! $DL ; then	echo >&2 "update-pciids: download failed"	rm -f $DEST.new	exit 1fiif ! $DECOMP <$DEST.new >$DEST.neww ; then	echo >&2 "update-pciids: decompression failed, probably truncated file"	exit 1fiif ! $GREP >/dev/null "^C " $DEST.neww ; then	echo >&2 "update-pciids: missing class info, probably truncated file"	exit 1fiif [ -f $DEST ] ; then	mv $DEST $DEST.old	# --reference is supported only by chmod from GNU file, so let's ignore any errors	chmod -f --reference=$DEST.old $DEST.neww 2>/dev/null || truefimv $DEST.neww $DESTrm $DEST.new# Older versions did not compress the ids file, so let's make sure we# clean that up.if [ ${DEST%.gz} != ${DEST} ] ; then	rm -f ${DEST%.gz} ${DEST%.gz}.oldfi${quiet} || echo "Done."

⌨️ 快捷键说明

复制代码Ctrl + C
搜索代码Ctrl + F
全屏模式F11
增大字号Ctrl + =
减小字号Ctrl + -
显示快捷键?